#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <io.h>
#include <dos.h>
#include <sys\stat.h>
#include <sys\types.h>
#include <string.h>

//#define EXTERNAL
#define MAXITEMS 4096

typedef struct
{
	char name[13];
	unsigned long size, offset;
} Item_T;

#ifdef EXTERNAL
static char *ext[3] =
{
	".MAP",
	".RAW",
	".SNG"
};
#endif

long numitems, indexoffset, indexsize, handle;
static char *buf, header[4];
Item_T item[MAXITEMS];

#ifdef EXTERNAL
int testext(char *name)
{
	long i;
	
	for(i=0;i<3;i++)
	{
		if (strstr(name, ext[i]) != NULL) return(1);
	}
	return(0);
}
#endif

void itemextract(void)
{
	long i, itemhandle;

	for(i=0;i<numitems;i++)
	{
		#ifdef EXTERNAL
		if (testext(item[i].name) != 1) continue;
		#endif
		printf("Dividing %s...\n", item[i].name);
		buf = (char *)malloc(item[i].size);
		lseek(handle, item[i].offset, SEEK_SET);
		read(handle, buf, item[i].size);
		itemhandle = open(item[i].name, O_BINARY|O_WRONLY|O_CREAT|O_TRUNC,S_IWRITE);
		if (itemhandle == -1)
		{		
			close(handle);
			printf("Cannot save %s", item[i].name);
			exit(-1);
		}
		if (write(itemhandle, buf, item[i].size) < item[i].size)
		{
			close(handle);
			close(itemhandle);
			printf("OUT OF HD SPACE!\n");
			exit(-1);
		}
		close(itemhandle);
		free(buf);
	}
}

int main(int argc, char *argv[])
{
	if (argc < 2)
	{
		printf("DATDIV v1.0	- By Micheal Muniko\n");
		printf("Syntax: datdiv [data file]\n");
		exit(0);
	}
	if ((handle = open(argv[1], O_BINARY|O_RDONLY,S_IREAD)) == -1)
	{
		printf("Cannot open %s.\n", argv[1]);
		exit(-1);
	}
	read(handle, &header, 4);
	if ((header[0] != 'D') && (header[1] != 'A') && (header[2] != 'T')
	    && (header[3] != 0x1a))
	{
		close(handle);
		printf("DAT header corrupted\n");
		exit(1);
	}
	read(handle, &numitems, 2);
	read(handle, &indexoffset, 4);
	read(handle, &indexsize, 4);
	lseek(handle, indexoffset, SEEK_SET);
	read(handle, &item[0], indexsize);
	itemextract();	
	close(handle);
	printf("All items divided.\n");
	return(0);
}
